﻿using Avalonia.Controls;
using ReactiveUI;
using UP_Avalonia.Models;

namespace UP_Avalonia.ViewModels
{
    public class MainWindowViewModel : ViewModelBase
    {
        public static UP_MoskalenkoSContext myConnection = new UP_MoskalenkoSContext();
        UserControl uc = new UCTour();
        public UserControl UC { get => uc; set => this.RaiseAndSetIfChanged(ref uc, value); }
        NavigateToursViewModel tPVMl1VM = new();
        public NavigateToursViewModel TP_VM { get => tPVMl1VM; set => tPVMl1VM = value; }

        NavigateHotelsViewModel hpVM = new NavigateHotelsViewModel();
        public NavigateHotelsViewModel hp_VM { get => hpVM; set => hpVM = value; }
        NavigateToursViewModel mainTourPage = new NavigateToursViewModel();

        ChangeHotelViewModel hcVM = new ChangeHotelViewModel();
        public ChangeHotelViewModel hc_VM { get => hcVM; set => hcVM = value; }




        public void GoPageHotel()
        {
            hp_VM = new NavigateHotelsViewModel();
            UC = new UCHotel();
        }
        public void GoPageTour()
        {
            TP_VM = new NavigateToursViewModel();
            UC = new UCTour();
        }
        public void GoHotelCard()
        {
            hc_VM = new ChangeHotelViewModel();
            UC = new UCChangeHotel();
        }
        public void GoHotelCardChange(int ID)
        {
            hc_VM = new ChangeHotelViewModel(ID);
            UC = new UCChangeHotel();
        }
    }
}